local WeaponUp = CreateFrame("Frame")
local queueset = queueset
					
local Items = 	{		--Fishing Poles--
						6365, -- Strong Fishing Pole
						46337, -- Staats' Fishing Pole
						52678, -- Jonathan's Fishing Pole
						6256, -- Fishing Pole
						6366, -- Darkwood Fishing Pole
						6367, -- Big Iron Fishing Pole
						25978, -- Seth's Graphite Fishing Pole
						19022, -- Nat Pagles Extreme Angler FC-5000
						45858, -- Nat's Lucky Fishing Pole
						45992, -- Jeweled Fishing Pole
						45991, -- Bone Fishing Pole
						19970, -- Arcanite Fishing Pole
						44050, -- Mastercraft Kalu'ak Fishing Pole
						84661, -- Dragon Fishing Pole
						84660, -- Pandaren Fishing Pole
						
						--Other Items--
						52716, --Twilight Fire Lance
						46106, --Argent Lance
						46069, --Alliance Lance
						46070, --Horde Lance
						37892, --Green Brewfest Stein
						32912, --Yellow Brewfest Stein
						33016, --Blue Brewfest Stein
						44731, --Bouquet of Ebon Roses
						22206} --Bouquet of Red Roses

local MountIDs = {
		[39710] = "Aviana's Guardian",
		[40719] = "Aviana's Guardian",
		[40720] = "Aviana's Guardian",
		[40723] = "Aviana's Guardian",
		}						
local ArgentMountIDs = {}
						
WeaponUp:RegisterEvent("ADDON_LOADED")
WeaponUp:RegisterEvent("PLAYER_REGEN_DISABLED")
WeaponUp:RegisterEvent("PLAYER_ENTERING_WORLD")
WeaponUp:RegisterEvent("EQUIPMENT_SWAP_FINISHED")
WeaponUp:RegisterEvent("PLAYER_REGEN_ENABLED")
WeaponUp:RegisterEvent("TRADE_SKILL_SHOW")
WeaponUp:RegisterEvent("TRADE_SKILL_CLOSE")
WeaponUp:RegisterEvent("UNIT_EXITED_VEHICLE")
WeaponUp:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
--WeaponUp:RegisterEvent("EQUIPMENT_SETS_CHANGED")


local function DoEquip() -- equip function
	local inInstance, instanceType = IsInInstance()	
		if GetActiveSpecGroup() == 1 then
			if instanceType == "party" or instanceType == "raid" then
				if wuname ~= nil then
				local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wuname)
					if not isEquipped then
						UseEquipmentSet(wuname)
					end
				end
			elseif instanceType == "arena" or instanceType == "pvp" then
				if wupvpname ~= nil then
				local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wupvpname)
					if not isEquipped then
						UseEquipmentSet(wupvpname)
					end
				end
			elseif instanceType == "none" then
				for i,v in pairs(Items) do
				if IsEquippedItem(v) then
					if wupvpmode == true and wupvpname then
						UseEquipmentSet(wupvpname)
					elseif wupvpmode == nil  and wuname then
						UseEquipmentSet(wuname)
					end
				end
				end
			end
		elseif GetActiveSpecGroup() == 2 then
			if instanceType == "party" or instanceType == "raid" then
				if wuname2 ~= nil then
				local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wuname2)
					if not isEquipped then
						UseEquipmentSet(wuname2)
					end
				end
			elseif instanceType == "arena" or instanceType == "pvp" then
				if wupvpname2 ~= nil then
				local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wupvpname2)
					if not isEquipped then
						UseEquipmentSet(wupvpname2)
					end
				end
			elseif instanceType == "none" then
				for i,v in pairs(Items) do
				if IsEquippedItem(v) then
					if wupvpmode == true and wupvpname2 then
						UseEquipmentSet(wupvpname2)
					elseif wupvpmode == nil  and wuname2 then
						UseEquipmentSet(wuname2)
					end
				end
				end
			end
		end
end

local function eventHandler(self, event, ...)

if event == "ADDON_LOADED" then
local addon = ...
	if addon == "WeaponUp" then
		if not wuname and not wuname2 and not wupvpname and not wupvpname2 then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r No sets chosen. Please choose sets in the settings tab for this addon to work.")
			if wuenable == nil then
				myCheckButton_GlobalName:SetChecked(true)
			end
			UIDropDownMenu_DisableDropDown(Cookset)
		else -- Set Stored Options
			if wuenable == true then
				myCheckButton_GlobalName:SetChecked(true)
			elseif wuenable == nil then
				myCheckButton_GlobalName:SetChecked(true)
			else
				myCheckButton_GlobalName:SetChecked(false)
			end
			if wufishingmode == true then
				myCheckButton_GlobalName2:SetChecked(true)
			else
				myCheckButton_GlobalName2:SetChecked(false)
			end
			if wucooking == true then
				myCheckButton_GlobalName3:SetChecked(true)
				UIDropDownMenu_EnableDropDown(Cookset)
			else
				myCheckButton_GlobalName3:SetChecked(false)
				UIDropDownMenu_DisableDropDown(Cookset)
			end
			if wupvpmode == true then
				myCheckButton_GlobalName4:SetChecked(true)
			else
				myCheckButton_GlobalName4:SetChecked(false)
			end
			if wujoustingmode == true then
				myCheckButton_GlobalName5:SetChecked(true)
			else
				myCheckButton_GlobalName5:SetChecked(false)
			end
			if wuspecmode == true then
				myCheckButton_GlobalName6:SetChecked(true)
			else
				myCheckButton_GlobalName6:SetChecked(false)
			end
			if wuname then
				UIDropDownMenu_SetText(Mydropdown, wuname)
			end
			if wuname2 then
				UIDropDownMenu_SetText(Secondary, wuname2)
			end
			if wupvpname then
				UIDropDownMenu_SetText(Fifth, wupvpname)
			end
			if wupvpname2 then
				UIDropDownMenu_SetText(Sixth, wupvpname2)
			end
			if wucookingname then
				UIDropDownMenu_SetText(Cookset, wucookingname)
			end
		end
		if UnitFactionGroup("player") == "Alliance" then
			ArgentMountIDs ={
				[33790] = "Stabled Exodar Elekk",
				[33793] = "Stabled Gnomeregan Mechanostrider",
				[33794] = "Stabled Darnassian Nightsaber",
				[33795] = "Stabled Ironforge Ram",
				[33800] = "Stabled Stormwind Steed",
				[33843] = "Stabled Quel'dorei Steed",
				[36557] = "Argent Warhorse",
				[33870] = "Stabled Argent Warhorse",
				[34125] = "Stabled Campaign Warhorse",
			}
		else
			 ArgentMountIDs ={
				[33791] = "Stabled Silvermoon Hawkstrider",
				[33792] = "Stabled Thunder Bluff Kodo",
				[33796] = "Stabled Darkspear Raptor",
				[33798] = "Stabled Forsaken Warhorse",
				[33799] = "Stabled Orgrimmar Wolf",
				[33842] = "Stabled Sunreaver Hawkstrider",
				[36558] = "Argent Battleworg",
				[33870] = "Stabled Argent Warhorse",
				[34125] = "Stabled Campaign Warhorse",
			}
		end
	end

elseif event == "PLAYER_REGEN_DISABLED" then -- entered combat, equip a weapon if no suitable weapon
	if wuenable == false or UnitInVehicle("player") then
		return;
	else
		local inInstance, instanceType = IsInInstance()
		if not inInstance then
			DoEquip()
		end
	end

elseif event == "PLAYER_ENTERING_WORLD" then
	if wuenable == false then
		return;
	end
	local inInstance, instanceType = IsInInstance() 
	if inInstance == 1 then -- set determined and zoned into an instance
		DoEquip()
	end
	if wulastset and wufishingmode == true then
		if not inInstance then 
			local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wulastset)
			if isEquipped then
				return; -- already equipped do nothing
			end
			UseEquipmentSet(wulastset) -- not the last set, re-equip last set
			--RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Switched back to set |cff00ff00 %s|r", wulastset ), ChatTypeInfo["RAID_WARNING"] );	
			
		end
	end

elseif event == "EQUIPMENT_SWAP_FINISHED" then -- finished equipping a gearset
local ok, setname = ...
	if wuenable == false then 
		return;
	end
	
	if (ok == true) and UnitAffectingCombat("player") and not UnitInVehicle("player") then
		--RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Switched to set |cff00ff00 %s|r", setname ), ChatTypeInfo["RAID_WARNING"] );
	elseif (ok == nil) and UnitAffectingCombat("player") and not UnitInVehicle("player") then
		RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Could not switch to set |cff00ff00 %s|r", setname ), ChatTypeInfo["RAID_WARNING"] );
		queueset = true --couldn't swap so queue set
	end
	local inInstance, instanceType = IsInInstance()
	if not UnitAffectingCombat("player") and not inInstance then
		local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(setname)
		if ok == true and missingItems == 0 then	-- indicates a usable set
			wulastset = setname
		end
	end

elseif event == "PLAYER_REGEN_ENABLED" then
	if not wulastset or wuenable == false or UnitInVehicle("player") then
		return;
	end	
	local inInstance, instanceType = IsInInstance()
	
	if wufishingmode == true then
		if inInstance == nil then 		
		local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wulastset)
			if isEquipped then
				return;
			end
		UseEquipmentSet(wulastset) -- not the last set, re-equip last set
		--RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Switched back to set |cff00ff00 %s|r", wulastset ), ChatTypeInfo["RAID_WARNING"] );	
			
	end
	end
	if queueset == true then -- set couldn't be equipped so do so now
		if wufishingmode == true then
			local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wulastset)
				if isEquipped then
					queueset = nil -- set is already on do nothing
				end	
		else
			DoEquip()
			queueset = nil --set equipped clear queued set
		end
	end
elseif event == "TRADE_SKILL_SHOW" then -- for cooking set
	if not wucooking or wuenable == false or UnitInVehicle("player") then
		return;
	end
	
	if not IsTradeSkillLinked() and GetTradeSkillLine() == "Cooking" then
		if wucooking == true and wucookingname then
			for i = 1, GetNumEquipmentSets() do
			local name, icon, setID, isEquipped, totalItems, equippedItems, inventoryItems, missingItems, ignoredSlots = GetEquipmentSetInfo(i)
				if isEquipped then
					wulastcookingset = name
					if name == wucookingname then
						return;
					end
				end
			end
				--if GetItemCount(46349) > 0 then -- Chef's hat
					UseEquipmentSet(wucookingname)
				--else
					--DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r You do not have a Chef's Hat in your bags.")
				--end
		end
	end
elseif event == "TRADE_SKILL_CLOSE" then
	if not wucooking or wuenable == false or UnitInVehicle("player") then
		return;
	end
	if not InCombatLockdown() and wulastcookingset then
			local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wulastcookingset)
			if isEquipped then
				return;
			end
		UseEquipmentSet(wulastcookingset)
		wulastcookingset = nil
	end
elseif event == "UNIT_EXITED_VEHICLE" then
local unit = ...
	--DEFAULT_CHAT_FRAME:AddMessage("exited vehicle") -- debug message
	if not wujoustingmode or wuenable == false or UnitInVehicle("player") or unit ~= "player" then
		return;
	end
	if wufishingmode == true and wulastset~= nil and unit == "player" and not UnitAffectingCombat("player") then
		local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wulastset)
		if not isEquipped then
			UseEquipmentSet(wulastset)
			--RaidNotice_AddMessage( RaidWarningFrame, string.format("|cffffff00WeaponUp:|r Switched back to set |cff00ff00 %s|r", wulastset ), ChatTypeInfo["RAID_WARNING"] );	
		end
	end

--elseif event == "EQUIPMENT_SETS_CHANGED" then

	
elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
local talentgroup = ...	
	if wuenable == false or wuspecmode == nil then 
		return;
	end
	--DEFAULT_CHAT_FRAME:AddMessage(talentgroup) -- debug message
	--for i = 1, GetNumEquipmentSets() do
	--local name, icon, setID, isEquipped, totalItems, equippedItems, inventoryItems, missingItems, ignoredSlots = GetEquipmentSetInfo(i)
	if GetActiveSpecGroup() == 1 then
		if wupvpmode == true and wupvpname ~= nil then
		local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wupvpname)
			--if name == wupvpname then
				if not isEquipped then
					UseEquipmentSet(wupvpname)
				end
			--end
		elseif wupvpmode == nil and wuname ~= nil then
		local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wuname)
			--if name == wuname then
				if not isEquipped then
					UseEquipmentSet(wuname)
				end
			--end
		end
	elseif GetActiveSpecGroup() == 2 then
		if wupvpmode == true and wupvpname2 ~= nil then
		local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wupvpname2)
			--if name == wupvpname2 then
				if not isEquipped then
					UseEquipmentSet(wupvpname2)
				end
			--end
		elseif wupvpmode == nil and wuname2 ~= nil then
		local icon, setID, isEquipped, numItems, equippedItems, availableItems, missingItems, ignoredSlots = GetEquipmentSetInfoByName(wuname2)
			--if name == wuname2 then
				if not isEquipped then
					UseEquipmentSet(wuname2)
				end
			--end
		end
	end
	--end
end
end
WeaponUp:SetScript("OnEvent", eventHandler)

local function Lance(self, ...)
	if not wujoustingmode or wuenable == false or UnitInVehicle("player") then
		return;
	end
	local unitGUID = UnitGUID("mouseover")
	--DEFAULT_CHAT_FRAME:AddMessage(unitGUID) -- debug message
	if not unitGUID then
		return
	end
	
	local unitType = unitGUID:sub(5, 5)
	
	if unitType ~= "3" and unitType ~= "5" then
       return
	end
	local inRange = CheckInteractDistance("mouseover", 3);
	local npcID = tonumber(unitGUID:sub(7, 10), 16)

	if MountIDs[npcID] then
        if inRange then
		if GetItemCount(52716) > 0 then
			EquipItemByName(52716)
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r You do not have a lance in your bags.")
		end
		end
    end
	if ArgentMountIDs[npcID] then
		if inRange then
		if GetItemCount(46106) > 0 then
			EquipItemByName(46106)
		elseif GetItemCount(46069) > 0 then
			EquipItemByName(46069)
		elseif GetItemCount(46070) > 0 then
			EquipItemByName(46070)
		elseif GetItemCount(46106) == 0 and GetItemCount(46069) == 0 and GetItemCount(46070) == 0 then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponUp:|r You do not have a lance in your bags.")
		end
		end
	end
end
GameTooltip:HookScript("OnShow", Lance)